//
//(C) Copyright 1995, Diego Ernesto Malpica Chauvet.
//              All rights reserved.
//                  test9.cpp
//


// This program test storage class and btree class.
// try to abruptly terminate the program and rerun to see the efects
//

#include <stdio.h>
#include <iostream.h>
#include "dll.h"
#include "btypes.h"
#include "storage.h"
#include "btree.h"
#include <string.h>

#ifdef DOS_STACK
extern unsigned _stklen=20000;
#endif


class data_C
{
	public:
	char del_f;
	char code[10];
	char name[41];
	char sex[2];
};

class address_C
{
public:
	string_B description;
	string_B street;
	string_B colony;
	string_B province;
	string_B estate;
	string_B cp;
	string_B telephone;
	string_B notes;
	address_C();
};

address_C::address_C()
{
	description.create();
	street.create();
	colony.create();
	province.create();
	estate.create();
	cp.create();
	telephone.create();
	notes.create();
}

typedef bt_C<address_C> address_B;

class personal_data_C
{
	public:
	string_B code;
	string_B name;
	string_B sex;
	string_B nation;
	string_B birth_place;
	string_B birth_day;
	address_B address;
	personal_data_C();
};

typedef bt_C<personal_data_C> personal_data_B;

personal_data_C::personal_data_C()
{
	code.create();
	name.create();
	sex.create();
	nation.create();
	birth_day.create();
	birth_place.create();
	address.create();
}




int main()
{
DEF_CODE=XDR_CODE;


try
	{
		int n=0;
		int trans;

		personal_data_B person;
		data_C data;
		u_long_B  position;

		FILE *data_F;

		btree_B storage;
		storage.create();
		storage().init();
		position.create();

		key_B key;
		key.create();

		cout<<"test9.cpp"<<"\n";
		if (storage().open("dperson.gcd",USE)) {

				key().prefix()="person.name";
				n=1;
				if(storage().first_key(key))
				do {
					  cout<<n++<<"CI:"<<(char*)key().key()<<"\n";
				} while (storage().next_key(key));


				n=1;
				if (storage().first(&person,position))
				do {
					cout<<n++<<"CD:"<<(char*)person().name()<<"\n";
				}while (storage().next(&person,position));
		}

		storage.create();
		storage().init();
		data_F=fopen("data","rb");
		if (storage().open("dperson.gcd",CREATE)) {
			trans=storage().begin_trans();
			storage().set_active_trans(trans);

			n=0;
			while(fread(&data,sizeof(data_C),1,data_F)) {
				person.create();
				person().code()=data.code;
				person().name()=data.name;
				person().sex()=data.sex;
				storage().put(&person,position);
				cout<<++n<<"\n";
				//if (n==5)  exit(0);
				//if (n==10)  storage().stabilize();
				if (n==50)  break;
			}
			storage().end_trans(trans);
			fclose(data_F);

			trans=storage().begin_trans();
			storage().set_active_trans(trans);
			n=1;
			if (storage().first(&person,position))
			do {
				cout<<n++<<":"<<(char*)person().name();
				key().prefix()="person.name";
				key().key()=person().name();
				key().recpos()=position();
				if(storage().add_key(key)) cout<<":N";
				else cout<<":X";
				key().prefix()="person.code";
				key().key()=person().code();
				if(storage().add_key(key)) cout<<":C\n";
				else cout<<":X\n";
				if (n==50+1) break;
				//if(n==25+1) exit(0);
			}while (storage().next(&person,position));
			storage().end_trans(trans);
		}

		key().prefix()="person.name";
		n=1;
		if(storage().first_key(key))
		do {
			cout<<n++<<"R:"<<(char*)key().key()<<"\n";
		} while (storage().next_key(key));

		key().prefix()="person.code";
		n=1;
		if(storage().last_key(key))
		do {
			cout<<n++<<"R:"<<(char*)key().key()<<"\n";
		} while (storage().prev_key(key));

		storage().close();
	}
	catch(except_C& except) {
		 cout<<except.msg()<<"\n";
		 cout<<except.extra_msg()<<"\n";
	}
	cout<<"BT:"<<types_C::n_bt<<"\n";
	return 0;
}
